﻿Option Strict On
Option Explicit On

Imports WMPLib
Imports System.EventArgs


Public Class CDBurner

    Private MeineCDLaufwerke As IWMPCdromCollection = Nothing
    Private MeinCDLaufwerk As IWMPCdrom = Nothing
    Private MeinCDBrenner As IWMPCdromBurn = Nothing
    Private ZuBrennendePlaylist As IWMPPlaylist = Nothing

    Private PlaylistName As String

    Public Enum Brennstatus
        Burning
        Busy
        Deleting
        Preparing
        ReadyToBurn
        Done
        Unknown
        WaitingForCD
    End Enum

    Public Property Brennerstatus As Brennstatus
    Public Property Statusmeldung As String
    Public Property Fortschritt As Integer


    Public Function GetAvailableCDBurners() As List(Of String)
        Dim Rückgabewert As New List(Of String)
        MeineCDLaufwerke = MeinWMP.cdromCollection
        If MeineCDLaufwerke IsNot Nothing Then
            Dim AnzahlMeineCDLaufwerke As Integer = MeineCDLaufwerke.count
            If AnzahlMeineCDLaufwerke > 0 Then
                For i = 0 To AnzahlMeineCDLaufwerke - 1
                    MeinCDLaufwerk = MeineCDLaufwerke.Item(i)
                    If MeinCDLaufwerk IsNot Nothing Then
                        MeinCDBrenner = DirectCast(MeinCDLaufwerk, IWMPCdromBurn)
                        If MeinCDBrenner IsNot Nothing Then
                            If MeinCDBrenner.isAvailable("Burn") Then
                                Rückgabewert.Add(MeinCDLaufwerk.driveSpecifier)
                            End If
                        End If
                    End If
                Next
            End If
        End If
        Return Rückgabewert
    End Function

    Public Function GetFreeSectors(DriveIndex As Integer) As Integer
        Dim ImageMasteringAPI As New IMAPI2
        ImageMasteringAPI.RecorderUniqueId = ImageMasteringAPI.GetCdDriveUniqueId(DriveIndex)
        If ImageMasteringAPI.GetRecorderCanTrackAtOnce Then
            If ImageMasteringAPI.GetRecorderIsCurrentMediaSupported Then
                Return ImageMasteringAPI.GetMediaFreeSectors
            Else
                Statusmeldung = "Eingelegtes Rohlingformat wird nicht unterstützt. Bitte lege ein unterstütztes Medium in den CD/DVD-Brenner!"
                RaiseEvent NewNotification()
                Return 0
            End If
        Else
            Statusmeldung = "Dein CD/DVD-Laufwerk unterstützt nicht das Track-At-Once-Brennen!"
            RaiseEvent NewNotification()
            Return 0
        End If

    End Function

    Public Function BurnCD(Playlist As List(Of String), CDDrive As String, BurnAsMP3CD As Boolean, CDName As String) As Boolean
        Try
            If Playlist.Count = 0 Then
                Statusmeldung = "Die zu brennende Playlist ist leer. Bitte füge der Playlist Musiktitel zu!"
                RaiseEvent NewNotification()
                Return False
            End If

            PlaylistName = CDName
            MeinCDBrenner = CType(MeinWMP.cdromCollection.getByDriveSpecifier(CDDrive), IWMPCdromBurn)
            If MeinCDBrenner IsNot Nothing Then
                If MeinCDBrenner.isAvailable("Burn") Then
                    If MeinCDBrenner.isAvailable("Disc") Then
                        If MeinCDBrenner.isAvailable("Write") Then
                            Dim TemporaerePlaylist As WMPLib.IWMPPlaylist = MeinWMP.playlistCollection.newPlaylist(CDName)

                            For Each Musiktitel In Playlist

                                If System.IO.File.Exists(Musiktitel) = False Then
                                    Statusmeldung = "Der Musiktitel " & Musiktitel & " existiert nicht. Bitte übergebe nur Musiktitel, die als Datei existieren!"
                                    RaiseEvent NewNotification()
                                    Return False
                                Else
                                    If Not (Musiktitel.ToLower.EndsWith(".mp3") OrElse Musiktitel.ToLower.EndsWith(".wav")) Then

                                        Statusmeldung = "Das Dateiformat des Musiktitels " & Musiktitel & " wird nicht unterstützt. Bitte übergebe nur .mp3 und .wav-Dateien!"
                                        RaiseEvent NewNotification()
                                        Return False
                                    End If

                                End If
                            Next
                            For Each Musiktitel In Playlist
                                TemporaerePlaylist.appendItem(MeinWMP.newMedia(Musiktitel))
                            Next
                            'ZuBrennendePlaylist = CType(MeinWMP.playlistCollection.getByName(CDName).Item(0), IWMPPlaylist)
                            If TemporaerePlaylist IsNot Nothing Then
                                MeinCDBrenner.burnPlaylist = TemporaerePlaylist
                                If BurnAsMP3CD = True Then
                                    MeinCDBrenner.burnFormat = WMPBurnFormat.wmpbfDataCD
                                Else
                                    MeinCDBrenner.burnFormat = WMPBurnFormat.wmpbfAudioCD
                                End If
                                MeinCDBrenner.refreshStatus()
                                MeinCDBrenner.startBurn()
                                MeinTimer.Enabled = True
                                MeinTimer.Start()
                            End If
                        Else
                            Statusmeldung = "Auf die eingelegte CD/DVD kann nicht gebrannt werden. Bitte lege einen leeren CD/DVD-Rohling ein!"
                            RaiseEvent NewNotification()
                        End If
                    Else
                        Statusmeldung = "Im gewählten Laufwerk ist keine CD/DVD eingelegt. Bitte lege einen leeren Rohling ein!"
                        RaiseEvent NewNotification()
                    End If
                Else
                    Statusmeldung = "Das gewählte Laufwerk besitzt keine Brennoption!"
                    RaiseEvent NewNotification()
                End If
            Else
                Statusmeldung = "Das gewählte Laufwerk existiert nicht!"
                RaiseEvent NewNotification()
            End If
            Return True
        Catch
            Return False
        End Try
    End Function


    'Private Sub AxWindowsMediaPlayer1_Enter(sender As Object, e As EventArgs) Handles MeinWMP.Enter

    'End Sub
    'Public Property _URL As String
    '    Get
    '        Return AxWindowsMediaPlayer1.URL
    '    End Get
    '    Set(value As String)
    '        AxWindowsMediaPlayer1.URL = value
    '    End Set
    'End Property

    'Public Sub Abspielen()
    '    AxWindowsMediaPlayer1.Ctlcontrols.play()
    'End Sub

    Private Sub MeinWMP_NeueFehlermeldung(sender As Object, e As AxWMPLib._WMPOCXEvents_CdromBurnErrorEvent) Handles MeinWMP.CdromBurnError
        Statusmeldung = "Unbekannter Fehler beim Brennen der CD/DVD."
        RaiseEvent NewNotification()
    End Sub

    Private Sub MeinWMP_NeueFehlermeldungMedia(sender As Object, e As AxWMPLib._WMPOCXEvents_CdromBurnMediaErrorEvent) Handles MeinWMP.CdromBurnMediaError
        Statusmeldung = "Unbekannter Fehler beim Brennen eines Medienobjekts auf CD/DVD."
        RaiseEvent NewNotification()
    End Sub

    Private Sub MeinWMP_GeaenderterBrennstatus(sender As Object, e As AxWMPLib._WMPOCXEvents_CdromBurnStateChangeEvent) Handles MeinWMP.CdromBurnStateChange
        Dim Fortschritt As Integer = MeinCDBrenner.burnProgress

        Select Case e.pCdromBurn.burnState
            Case WMPBurnState.wmpbsBurning
                Brennerstatus = Brennstatus.Burning
            Case WMPBurnState.wmpbsBusy
                Brennerstatus = Brennstatus.Busy
            Case WMPBurnState.wmpbsErasing
                Brennerstatus = Brennstatus.Deleting
            Case WMPBurnState.wmpbsPreparingToBurn
                Brennerstatus = Brennstatus.Preparing
            Case WMPBurnState.wmpbsReady
                Brennerstatus = Brennstatus.ReadyToBurn
            Case WMPBurnState.wmpbsStopped
                Brennerstatus = Brennstatus.Done
            Case WMPBurnState.wmpbsUnknown
                Brennerstatus = Brennstatus.Unknown
            Case WMPBurnState.wmpbsWaitingForDisc
                Brennerstatus = Brennstatus.WaitingForCD
        End Select

        RaiseEvent NewBurnStatus()
    End Sub

    Public Event NewBurnStatus()
    Public Event NewNotification()
    Public Event NewProgress()
    'Public Event Beenden()


    Private Sub MeinTimer_Tick(sender As Object, e As EventArgs) Handles MeinTimer.Tick
        If Fortschritt <> MeinCDBrenner.burnProgress Then
            Fortschritt = MeinCDBrenner.burnProgress
            RaiseEvent NewProgress()
        End If
    End Sub

    Public Sub WrapUp()
        Fortschritt = 100
        RaiseEvent NewProgress()

        MeinTimer.Stop()
        MeinTimer.Enabled = False

        Dim GefundenePlaylists As IWMPPlaylistArray = MeinWMP.playlistCollection.getByName(PlaylistName)
        If GefundenePlaylists.count > 0 Then
            Dim ZuLoeschendePlaylist As IWMPPlaylist = GefundenePlaylists.Item(0)
            MeinWMP.playlistCollection.remove(ZuLoeschendePlaylist)
        End If

        Statusmeldung = "Das Brennen der CD/DVD wurde erfolgreich abgeschlossen."
        RaiseEvent NewNotification()
    End Sub


End Class
